<!--********************************************************************************
 * Copyright (c) 2015, 2023 Contributors to the Eclipse Foundation
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 ********************************************************************************-->

<style>
  :host ::ng-deep .dropdown {
    width: 200px;
  }

  :host ::ng-deep .dropdown-toggle {
    overflow: hidden;
    padding-right: 24px /* Optional for caret */;
    text-align: left;
    text-overflow: ellipsis;
    width: 100%;
  }
  /* Optional for caret */

  :host ::ng-deep .dropdown-toggle .caret {
    position: absolute;
    right: 12px;
    top: calc(50% - 2px);
  }
</style>

<div class="flex align-items-center">
  <p-dropdown
    [options]="groupedViews"
    [(ngModel)]="selectedView"
    [placeholder]="dropdownPlaceholder | translate"
    [group]="true"
    groupLabel="label"
    optionLabel="name"
    optionGroupChildren="view"
    (onChange)="selectViewByUser()"
  ></p-dropdown>
  <p-button
    styleClass="ml-1"
    icon="pi pi-pencil"
    (onClick)="editSelectedView($event)"
    title="{{ 'tableview.view.tooltip-edit-view' | translate }}"
  ></p-button>
  <p-button
    styleClass="ml-1"
    icon="fa fa-file-o"
    (onClick)="newView($event)"
    title="{{ 'tableview.view.tooltip-create-new-view' | translate }}"
  ></p-button>
  <p-button
    styleClass="ml-2"
    icon="pi pi-save"
    (onClick)="showSaveModal($event)"
    title="{{ 'tableview.view.tooltip-save-view' | translate }}"
  ></p-button>
  <p-button
    styleClass="ml-1 mr-1"
    icon="pi pi-trash"
    (onClick)="deleteView($event)"
    title="{{ 'tableview.view.tooltip-delete-view' | translate }}"
  ></p-button>
  <mdm-sharelink
    [customStateCallback]="getStateForTakeOver.bind(this)"
    title="{{ 'tableview.view.tooltip-share-view' | translate }}"
  ></mdm-sharelink>
  <p-checkbox
    *ngIf="selectedView"
    id="unit_pref_default"
    [binary]="true"
    class="ml-2"
    [style]="{ 'vertical-align': 'text-bottom' }"
    (onClick)="$event.stopPropagation()"
    [(ngModel)]="isDefaultView"
    (onChange)="defaultViewChanged()"
  ></p-checkbox>
  <label for="unit_pref_default" class="ml-1">{{ "user-prefs.unit-prefs.lbl-default" | translate }}</label>
</div>

<mdm-edit-view></mdm-edit-view>
<mdm-overwrite-dialog></mdm-overwrite-dialog>

<p-dialog
  [modal]="true"
  header="{{ 'tableview.view.title-save-view-as' | translate }}:"
  [(visible)]="selectSearchComponents"
  [style]="{ width: '50vw' }"
>
  <div class="flex flex-column gap-2">
    <p-table
      *ngIf="userViewNames?.length > 0"
      styleClass="p-datatable-gridlines"
      [value]="userViewNames"
      [(selection)]="selectedRow"
      (onRowUnselect)="onRowUnselect()"
      (onRowSelect)="onRowSelect($event)"
      [rows]="10"
      [paginator]="true"
      [pageLinks]="3"
      selectionMode="single"
      [rowsPerPageOptions]="[10, 20, 50]"
      paginatorDropdownAppendTo="body"
      [alwaysShowPaginator]="false"
    >
      <ng-template pTemplate="header">
        <tr>
          <th>{{ "tableview.view.existing-view-names" | translate }}</th>
        </tr>
      </ng-template>
      <ng-template pTemplate="body" let-view>
        <tr [pSelectableRow]="view">
          <td>{{ view }}</td>
        </tr>
      </ng-template>
    </p-table>
    <div class="flex align-items-center justify-content-between gap-2">
      <input
        type="text"
        class="form-control"
        placeholder="{{ 'tableview.view.name-placeholder' | translate }}"
        [value]="viewName"
        (input)="viewName = $event.target.value"
        (keyup.enter)="saveView($event)"
        required
      />
      <p-button
        icon="pi pi-save"
        [label]="'tableview.view.btn-save' | translate"
        (onClick)="saveView($event)"
        [disabled]="!viewName"
        title="{{ getSaveBtnTitle() | translate }}"
      ></p-button>
    </div>
  </div>
</p-dialog>
<!--
<div bsModal #lgSaveModal="bs-modal" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="SelectSearchComponents" aria-hidden="true">
  <div class="modal-dialog modal-md">
    <div class="modal-content">
      
    </div>
  </div>
</div>
-->
<!-- confirm dialog for delete file from data base -->
<p-confirmDialog
  #cd
  key="viewConfirmation"
  header="{{ 'tableview.view.ttl-confirmation' | translate }}"
  icon="fa fa-exclamation-triangle"
  appendTo="body"
>
  <p-footer>
    <button type="button" (click)="cd.accept()" class="btn btn-mdm">
      <span class="pi pi-check"></span>
    </button>
    <button type="button" (click)="cd.reject()" class="btn btn-mdm">
      <span class="pi pi-times"></span>
    </button>
  </p-footer>
</p-confirmDialog>

<p-dialog
  [header]="'tableview.view.title-takeover' | translate"
  [(visible)]="takeOverDialogVisible"
  [breakpoints]="{ '960px': '75vw' }"
  [style]="{ width: '50vw' }"
  [modal]="true"
  [draggable]="false"
  [resizable]="false"
>
  <span *ngIf="!takeOverNameExists">{{ "tableview.view.msg-takeover" | translate }}</span>
  <span *ngIf="takeOverNameExists">{{ "tableview.view.msg-takeover-name-exists" | translate }}</span>

  <div class="mt-2">
    <input type="text" pInputText [(ngModel)]="takeOverView.name" />
  </div>

  <ng-template pTemplate="footer">
    <p-button (click)="takeOver()" [label]="'user-prefs.channel-filter-prefs.btn-save' | translate"></p-button>
    <p-button (click)="takeOverDialogVisible = false" [label]="'user-prefs.channel-filter-prefs.btn-cancel' | translate"></p-button>
  </ng-template>
</p-dialog>
